Package: ottr
Title: An R Autograding Extension for Otter-Grader
Version: 1.5.3
Authors@R: c(
    person(given = "Christopher",
           family = "Pyles",
           email = "cpyles@berkeley.edu",
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-8520-7593")),
    person(given = "UC Berkeley Data Science Education Program",
           role = c("cph")))
Maintainer: Christopher Pyles <cpyles@berkeley.edu>
Description: 
    An R autograding extension for Otter-Grader (<https://otter-grader.readthedocs.io>). It supports 
    grading R scripts, R Markdown documents, and R Jupyter Notebooks.
License: BSD_3_clause + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 4.0.0)
Imports: jsonlite, testthat, tools, R6, zip, methods
Suggests: IRdisplay, mockery, rmarkdown, stringr, withr, IRkernel
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2025-10-12 00:06:34 UTC; chrispyles
Author: Christopher Pyles [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-8520-7593>),
  UC Berkeley Data Science Education Program [cph]
Repository: CRAN
Date/Publication: 2025-10-12 02:20:02 UTC
Built: R 4.6.0; ; 2026-04-28 19:58:04 UTC; unix

Package: ottr
Title: An R Autograding Extension for Otter-Grader
Version: 1.6.0
Authors@R: c(
    person(given = "Christopher",
           family = "Pyles",
           email = "cpyles@berkeley.edu",
           role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-8520-7593")),
    person(given = "UC Berkeley Data Science Education Program",
           role = c("cph")))
Maintainer: Christopher Pyles <cpyles@berkeley.edu>
Description: 
    An R autograding extension for Otter-Grader (<https://otter-grader.readthedocs.io>). It supports 
    grading R scripts, R Markdown documents, and R Jupyter Notebooks.
License: BSD_3_clause + file LICENSE
Encoding: UTF-8
RoxygenNote: 8.0.0
Depends: R (>= 4.0.0)
Imports: jsonlite, testthat, tools, R6, zip, methods, fs
Suggests: IRdisplay, mockery, rmarkdown, stringr, withr, IRkernel,
        quarto
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-07-16 22:39:58 UTC; chrispyles
Author: Christopher Pyles [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-8520-7593>),
  UC Berkeley Data Science Education Program [cph]
Repository: CRAN
Date/Publication: 2026-07-17 23:30:02 UTC

# Ottr

[![Run tests](https://github.com/ucbds-infra/ottr/actions/workflows/run-tests.yml/badge.svg)](https://github.com/ucbds-infra/ottr/actions/workflows/run-tests.yml)
[![codecov](https://codecov.io/gh/ucbds-infra/ottr/branch/master/graph/badge.svg?token=7UL6L4JYX1)](https://app.codecov.io/gh/ucbds-infra/ottr)

Ottr is a client-side R autograding package that is designed to be mixed into 
[Otter-Grader](https://github.com/ucbds-infra/otter-grader) to extend it to R Jupyter Notebooks, R 
scripts, and Rmd and Quarto documents.

For more details about ottr and its usage, see the [Otter-Grader documentation](https://otter-grader.rtfd.io).

# Ottr

[![Run tests](https://github.com/ucbds-infra/ottr/actions/workflows/run-tests.yml/badge.svg)](https://github.com/ucbds-infra/ottr/actions/workflows/run-tests.yml)
[![codecov](https://codecov.io/gh/ucbds-infra/ottr/branch/master/graph/badge.svg?token=7UL6L4JYX1)](https://app.codecov.io/gh/ucbds-infra/ottr)

Ottr is a client-side R autograding package that is designed to be mixed into 
[Otter-Grader](https://github.com/ucbds-infra/otter-grader) to extend it to R Jupyter Notebooks, R 
scripts, and Rmd documents.

For more details about ottr and its usage, see the [Otter-Grader documentation](https://otter-grader.rtfd.io).

#' Generate an environment from an R script
#'
#' @description Execute a string as an R script and return the environment from that execution.
#'
#' Converts a string to an AST and executes that script in a dummy environment for running test
#' cases against. Transforms all expressions of the form `. = ottr::check(...)` by replacing the `.`
#' with an index into a list in the environment with name `check_results_{SECRET}` to collect the
#' [TestFileResult] objects generated from those checks. (This helps to handle variable
#' name collisions in tests when grading a script.)
#'
#' @param script The string to be executed
#' @param ignore_errors Whether to ignore errors thrown while executing the script
#'
#' @return The global environment after executing the script
execute_script <- function(script, ignore_errors) {
  if (missing(ignore_errors)) {
    ignore_errors <- TRUE
  }

  # convert script to a list of expressions
  tree <- as.list(parse(text = script))

  #  create dummy env for execution
  test_env <- new.env()

  # run the script, capturing stdout, and return the environment
  testthat::capture_output({
    for (expr in tree) {
      tryCatch(
        eval(expr, envir = test_env),
        error = function(e) {
          if (!ignore_errors) {
            stop(e)
          }
        }
      )
    }
  }, print = TRUE)
  return(test_env)
}

library(mockery)

test_that("executes a script and returns an environment", {
  tests_dir <- "my_tests"
  dir.create(tests_dir)
  file.create(file.path(tests_dir, "q1.R"))
  tests_glob <- file.path(tests_dir, "*.[Rr]")
  withr::defer(unlink(tests_dir, recursive = TRUE))

  script <- "
    a = 1
    b = TRUE
    c = 4 * pi
    d = (function(x) 3 * x + 1)(10)
    . = ottr::check(\"my_tests/q1.R\")
  "
  script_tree <- as.list(parse(text = script))

  expected_env <- new.env()
  expected_env$a <- 1
  expected_env$b <- TRUE
  expected_env$c <- 4 * pi
  expected_env$d <- 31

  env <- execute_script(script)

  expect_mapequal(as.list(env), as.list(expected_env))
})

test_that("handles errors thrown by scripts according to ignore_errors", {
  error_message <- "Oh no, our table, it's broken!"
  script <- paste0("
    a = 1
    stop(\"", error_message, "\")
    b = 2
  ")

  env <- execute_script(script)
  expect_equal(env$b, 2)

  env <- execute_script(script, TRUE)
  expect_equal(env$b, 2)

  expect_error(execute_script(script, FALSE), regexp = error_message)
})

#' Export a submission to a zip file
#'
#' @description Export a submission to a zip file for submitting. If indicated, a PDF of the
#' submission is generated and included in the zip file. (PDF generation is only supported for Rmd,
#'  Quarto, and ipynb files.)
#'
#' @param submission_path The path to the submission
#' @param export_path The path at which to write the zip file (optional)
#' @param display_link Whether to display a download link with `IRdisplay`
#' @param pdf Whether to include a PDF of the submission (only works for Rmd, Quarto, and ipynb files)
#' @param force_save Whether to attempt to force-save the notebook if running on Jupyter
#' @param debug Whether to stop on PDF generation errors
#'
#' @export
#'
#' @examples
#' \dontrun{
#' export("hw01.ipynb")
#'
#' # with pdf
#' export("hw01.ipynb", pdf = TRUE)
#' }
export <- function(
  submission_path,
  export_path = NULL,
  display_link = TRUE,
  pdf = FALSE,
  force_save = FALSE,
  debug = FALSE
) {
  timestamp <- format(Sys.time(), "%Y_%m_%dT%H_%M_%S")

  if (is.null(export_path)) {
    subm_name <- tools::file_path_sans_ext(basename(submission_path))
    export_path <- paste0(subm_name, "_", timestamp, ".zip")
  }

  ext <- tools::file_ext(submission_path)
  if (force_save) {
    if (ext != "ipynb") {
      stop("Force save can only be used on ipynb files")
    }

    success <- save_notebook(submission_path)
    if (!success) {
      warning(paste0(
        "Couldn't automatically save the notebook; ensure that you have ",
        "ottr_force_save_labextension installed. If you have it installed and this issue keeps",
        "reoccurring, you should use File > Save & ",
        "Checkpoint and then rerun this cell. The zip file generated by this call ",
        "will use the last saved version of this notebook."
      ))
    }
  }

  pdf_path <- NULL
  if (pdf) {
    pdf_path <- paste0(tools::file_path_sans_ext(basename(submission_path)), ".pdf")
    if (ext == "ipynb") {
      out <- system2(
        "jupyter", c("nbconvert", "--to=pdf", paste0("--output=", pdf_path), submission_path),
        stdout = TRUE,
        stderr = TRUE)

      if (debug && !is.null(attr(out, "status"))) {
        cat(paste0("nbconvert failed to convert the submission notebook to a PDF: ", paste(out, sep = "\n")))
        stop("failed to generate PDF; see printed output for details")
      }

      # move the PDF to the working directory because nbconvert outputs it in the directory
      # containing the notebook
      move_from <- paste0(file.path(dirname(submission_path), pdf_path))
      renamed <- file.rename(move_from, pdf_path)
      if (!renamed) {
        warning("Could not create a PDF of the submission notebook")

        # reset pdf_path to NULL so that it's not included in the zip file
        pdf_path <- NULL
      }
    } else if (ext == "Rmd") {
      if (!requireNamespace("rmarkdown", quietly = TRUE)) {
        stop("rmarkdown is not installed")
      }

      # add metadata to allow errors in the RMarkdown
      new_subm_path <- tempfile(fileext = ".Rmd")
      contents <- c(
        "```{r cache = F, include = F}\nknitr::opts_chunk$set(error = TRUE)\n```",
        readLines(submission_path))
      writeLines(contents, new_subm_path)

      subm_dir <- tools::file_path_as_absolute(dirname(submission_path))
      rmarkdown::render(new_subm_path, "pdf_document", pdf_path, subm_dir, knit_root_dir = subm_dir)
      file.remove(new_subm_path)
    } else if (ext == "qmd") {
      if (!requireNamespace("quarto", quietly = TRUE)) {
        stop("quarto is not installed")
      }

      # Create a new temp directory to work in; this will be created under the R session's temp directory.
      td <- tempfile(pattern = "ottr_")
      dir.create(td)

      # Copy the qmd file to a temporary directory so that Quarto doesn't overwrite anything in
      # the source directory when it generates the PDF (since it always writes the output file to
      # the same directory as the input file).
      in_file <- file.path(td, basename(submission_path))
      file.copy(submission_path, in_file)

      pdf_name <- basename(pdf_path)
      quarto::quarto_render(
        in_file,
        output_format = "pdf",
        output_file = pdf_name,
        metadata = list(execute = list(error = TRUE)))

      # Quarto writes the output to the same directory that contains the input, so move the PDF
      # from td to the desired location.
      file.rename(file.path(td, pdf_name), pdf_path)
      fs::dir_delete(td)
    } else {
      stop("Only Rmd, qmd, and ipynb files can be converted to PDFs")
    }
  }

  zip_filename_file_name <- "__zip_filename__"
  writeLines(c(export_path), zip_filename_file_name, sep = "")

  zip_files <- c(zip_filename_file_name, submission_path)
  if (!is.null(pdf_path)) {
    zip_files <- c(zip_files, pdf_path)
  }
  zip::zip(export_path, zip_files, mode = "cherry-pick")

  file.remove(zip_filename_file_name)

  if (display_link && running_on_jupyter()) {
    if (!requireNamespace("IRdisplay", quietly = TRUE)) {
      stop("IRdisplay is not installed")
    }
    IRdisplay::display_html(sprintf("
    <p>Your submission has been exported. Click <a href='%s' download='%s'
    target='_blank'>here</a> to download the zip file.</p>
    ", export_path, export_path))
  }
}

library(mockery)

get_pdf_path <- function(p) paste0(tools::file_path_sans_ext(basename(p)), ".pdf")

test_that("writes a zip file with the correct contents", {
  stub(export, "running_on_jupyter", TRUE)

  mock_display_html <- mock()
  stub(export, "IRdisplay::display_html", mock_display_html)

  subm_path <- "my_notebook.ipynb"
  writeLines(c("This is a notebook!"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  export(subm_path)

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))

  # check that the zip file name has the correct format
  expect_true(stringr::str_detect(zip_path, paste0(
    "^",
    tools::file_path_sans_ext(basename(subm_path)),
    "_\\d{4}_\\d{2}_\\d{2}T\\d{2}_\\d{2}_\\d{2}\\.zip$")))

  # check the zip file contents
  expect_equal(zip::zip_list(zip_path)$filename, c("__zip_filename__", subm_path))

  # check that __zip_filename__ was deleted
  expect_false(file.exists("__zip_filename__"))

  # check that IRdisplay::display_html was called
  expect_called(mock_display_html, 1)
})

test_that("supports PDF exports for ipynb files", {
  stub(export, "IRdisplay::display_html", mock())

  mock_system2 <- mock()
  stub(export, "system2", mock_system2)

  stub(export, "file.rename", c(TRUE))

  subm_path <- "my_notebook.ipynb"
  writeLines(c("This is a notebook!"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  pdf_path <- get_pdf_path(subm_path)
  writeLines(c("This is a pdf!"), pdf_path, sep = "")
  withr::defer(file.remove(pdf_path))

  export(subm_path, pdf = TRUE)

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))

  # check the zip file contents
  expect_equal(
    zip::zip_list(zip_path)$filename,
    c("__zip_filename__", subm_path, pdf_path))

  # check that __zip_filename__ was deleted
  expect_false(file.exists("__zip_filename__"))

  # check that system2 was called
  expect_called(mock_system2, 1)
  expect_args(mock_system2, 1, "jupyter", c("nbconvert", "--to=pdf", paste0("--output=", pdf_path), subm_path), stdout = TRUE, stderr = TRUE)
})

test_that("handles ipynb PDF export failures", {
  stub(export, "IRdisplay::display_html", mock())

  mock_system2 <- mock()
  stub(export, "system2", mock_system2)

  stub(export, "file.rename", c(FALSE))

  subm_path <- "my_notebook.ipynb"
  writeLines(c("This is a notebook!"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  warnings <- capture_warnings({
    export(subm_path, pdf = TRUE)
  })

  expect_equal(warnings, c("Could not create a PDF of the submission notebook"))

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))

  # check the zip file contents
  expect_equal(
    zip::zip_list(zip_path)$filename,
    c("__zip_filename__", subm_path))

  # check that __zip_filename__ was deleted
  expect_false(file.exists("__zip_filename__"))
})

test_that("supports PDF exports for Rmd files", {
  stub(export, "IRdisplay::display_html", mock())

  mock_render <- mock()
  stub(export, "rmarkdown::render", mock_render)

  tempfile_path <- "foo.Rmd"
  stub(export, "tempfile", tempfile_path)

  subm_path <- "my_submission.Rmd"
  writeLines(c("This is an Rmd file!\n"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  pdf_path <- get_pdf_path(subm_path)
  writeLines(c("This is a pdf!"), pdf_path, sep = "")
  withr::defer(file.remove(pdf_path))

  export(subm_path, pdf = TRUE)

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))

  # check the zip file contents
  expect_equal(
    zip::zip_list(zip_path)$filename,
    c("__zip_filename__", subm_path, pdf_path))

  # check that __zip_filename__ was deleted
  expect_false(file.exists("__zip_filename__"))

  # check that render was called
  expect_called(mock_render, 1)
  subm_dir <- tools::file_path_as_absolute(dirname(subm_path))
  expect_args(mock_render, 1, tempfile_path, "pdf_document", pdf_path, subm_dir, knit_root_dir = subm_dir)
})

test_that("supports PDF exports for qmd files", {
  stub(export, "IRdisplay::display_html", mock())

  mock_render <- mock()
  stub(export, "quarto::quarto_render", mock_render)

  tempdir_path <- withr::local_tempdir()
  stub(export, "tempfile", tempdir_path)

  mock_create_dir <- mock()
  stub(export, "dir.create", mock_create_dir)

  subm_path <- "my_submission.qmd"
  writeLines(c("This is a qmd file!\n"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  pdf_path <- get_pdf_path(subm_path)
  pdf_tempdir_path <- file.path(tempdir_path, basename(pdf_path))
  # export will copy the PDF from the tempdir to the output dir, so we write the stubbed PDF to the
  # tempdir and clean up the PDF from the output dir.
  writeLines(c("This is a pdf!"), pdf_tempdir_path, sep = "")
  withr::defer(file.remove(pdf_path))

  export(subm_path, pdf = TRUE)

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))

  # check the zip file contents
  expect_equal(
    zip::zip_list(zip_path)$filename,
    c("__zip_filename__", subm_path, pdf_path))

  # check that dir.create was called
  expect_called(mock_create_dir, 1)
  expect_args(mock_create_dir, 1, tempdir_path)

  # check that the PDF was copied from the tempdir to pdf_path
  expect_true(file.exists(pdf_path))

  # check that __zip_filename__ was deleted
  expect_false(file.exists("__zip_filename__"))

  # check that render was called
  expect_called(mock_render, 1)
  expect_args(
    mock_render,
    1,
    file.path(tempdir_path, basename(subm_path)),
    output_format = "pdf",
    output_file = basename(pdf_path),
    metadata = list(execute = list(error = TRUE)))

  # check that export cleaned up the tempdir
  expect_false(dir.exists(tempdir_path))
})

test_that("supports force-saving notebook files", {
  stub(export, "IRdisplay::display_html", mock())

  mock_save_notebook <- mock(TRUE)
  stub(export, "save_notebook", mock_save_notebook)

  subm_path <- "my_notebook.ipynb"
  writeLines(c("This is a notebook!"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  export(subm_path, force_save = TRUE)

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))

  expect_called(mock_save_notebook, 1)
  expect_args(mock_save_notebook, 1, subm_path)
})

test_that("warns the user when force-save fails", {
  stub(export, "IRdisplay::display_html", mock())

  stub(export, "save_notebook", FALSE)

  subm_path <- "my_notebook.ipynb"
  writeLines(c("This is a notebook!"), subm_path, sep = "")
  withr::defer(file.remove(subm_path))

  expect_warning(export(subm_path, force_save = TRUE))

  expect_equal(length(Sys.glob("*.zip")), 1)
  zip_path <- Sys.glob("*.zip")[1]
  withr::defer(file.remove(zip_path))
})

test_that("doesn't allow force-saving non-notebook files", {
  expect_error(export("foo.Rmd", force_save = TRUE))
  expect_error(export("foo.R", force_save = TRUE))
})

#' Create the expect JSON-serializable representation of the results returned by
#' [make_test_file_results()]
make_test_file_results_list <- function() {
  results <- make_test_file_results()
  return(list(test_file_results = lapply(results, function(r) r$to_list())))
}

#' An R6 representing the results of running a test case
#'
#' @description Represents the results of running a test case against a global environment. Contains
#' metadata about the passing/failing of the test case as well as a reference to the test case
#' itself.
#'
#' @field passed Whether the test passed
#' @field error An error raised by executing the test, if any
#' @field test_case The [TestCase] that this result tracks
TestCaseResult <- R6::R6Class(
  "TestCaseResult",
  public = list(
    passed = NA,
    error = NA,
    test_case = NA,

    #' @description Create a test case result.
    #'
    #' @param passed Whether the test passed
    #' @param error An error raised by executing the test, if any
    #' @param test_case The `TestCase` that this result tracks
    initialize = function(passed, error, test_case) {
      self$passed <- passed
      self$error <- error
      self$test_case <- test_case
    },

    #' @description Get the score earned for this test case, accounting for whether the test passed
    #' or failed.
    #'
    #' @return The score
    get_score = function() {
      if (self$passed) {
        return(self$test_case$points)
      } else {
        return(0)
      }
    },

    #' @description Convert this result into a human-readable string for display.
    #'
    #' @return The string representation of this result
    repr = function() {
      message <- self$get_message()
      if (is.na(message)) {
        message <- ""
      }

      if (self$passed) {
        return(paste0("Test ", self$test_case$name, " passed\n", message))
      }

      indented_message <- paste(strsplit(self$error$message, "\n")[[1]], collapse = "\n  ")
      if (length(message) > 0) {
        message <- paste0(message, "\n")
      }

      output <- paste0("Test ", self$test_case$name, " failed:\n", message, indented_message)
      return(output)
    },

    #' @description Convert this result to a JSON-compatible list with all of its fields.
    #'
    #' @return The list representation of this result
    to_list = function() {
      return(list(
        passed = self$passed,
        # don't put NULL because jsonlite turns it into {}
        error = ifelse(is.null(self$error$message), "", self$error$message),
        test_case = self$test_case$to_list()
      ))
    },

    #' @description Get the message to be displayed to the student based on whether the test case
    #' passed or failed, if any.
    #'
    #' @return The message or `NA`
    get_message = function() {
      if (self$passed) {
        return(self$test_case$success_message)
      }
      return(self$test_case$failure_message)
    }
  )
)

test_that("$new() initializes fields correctly", {
  tc <- make_test_cases()[[1]]

  tcr <- TestCaseResult$new(TRUE, NULL, tc)

  expect_equal(tcr$passed, TRUE)
  expect_equal(tcr$error, NULL)
  expect_equal(tcr$test_case, tc)

  tcr <- TestCaseResult$new(FALSE, simpleError("bad"), tc)

  expect_equal(tcr$passed, FALSE)
  expect_equal(tcr$error, simpleError("bad"))
  expect_equal(tcr$test_case, tc)
})

test_that("$get_score() returns the correct score based on whether the test case passed or not", {
  tc <- make_test_cases()[[1]]

  tcr <- TestCaseResult$new(TRUE, NULL, tc)
  expect_equal(tcr$get_score(), tc$points)

  tcr <- TestCaseResult$new(FALSE, NULL, tc)
  expect_equal(tcr$get_score(), 0)
})

test_that("$repr() returns the correct string representation of the results", {
  tc <- make_test_cases()[[1]]

  tcr <- TestCaseResult$new(TRUE, NULL, tc)
  expect_equal(tcr$repr(), "Test q1 - 1 passed\n")

  tc$success_message <- "good"
  expect_equal(tcr$repr(), "Test q1 - 1 passed\ngood")

  tcr$passed <- FALSE
  tcr$error <- simpleError("failed")
  expect_equal(tcr$repr(), "Test q1 - 1 failed:\n\nfailed")

  tc$failure_message <- "bad"
  expect_equal(tcr$repr(), "Test q1 - 1 failed:\nbad\nfailed")
})

test_that("$to_list() converts the result to a list", {
  tc <- make_test_cases()[[1]]

  tcr <- TestCaseResult$new(TRUE, NULL, tc)
  tcr_list <- tcr$to_list()

  expect_true(is.list(tcr_list))
  expect_equal(length(tcr_list), 3)
  expect_equal(tcr_list$passed, TRUE)
  expect_equal(tcr_list$error, "")
  expect_equal(tcr_list$test_case, tc$to_list())

  # check that to_list converts the error to a string
  tcr <- TestCaseResult$new(FALSE, simpleError("bad"), tc)
  tcr_list <- tcr$to_list()
  expect_equal(tcr_list$error, "bad")
})

test_that("$get_message() returns the success/failure message according to $passed", {
  tc <- make_test_cases()[[1]]

  tcr <- TestCaseResult$new(TRUE, NULL, tc)
  expect_true(is.na(tcr$get_message()))

  tc$success_message <- "good"
  expect_equal(tcr$get_message(), tc$success_message)

  tcr <- TestCaseResult$new(FALSE, simpleError("failed"), tc)
  expect_true(is.na(tcr$get_message()))

  tc$failure_message <- "bad"
  expect_equal(tcr$get_message(), tc$failure_message)
})

library(mockery)

test_that("runs a test against the student's environment and returns a TestFileResult", {
  test_env <- new.env()
  mock_parent.frame <- mock(test_env, cycle = TRUE)
  stub(check, "parent.frame", mock_parent.frame)

  mock_load_test_cases <- mock(list(cases = make_test_cases()), cycle = TRUE)
  stub(check, "load_test_cases", mock_load_test_cases)

  mock_cat <- mock()
  stub(check, "cat", mock_cat)

  test_file_path <- "tests/q1.r"

  results <- check(test_file_path)

  expect_true(inherits(results, "TestFileResult"))

  expect_equal(length(mock_parent.frame), 1)
  expect_args(mock_parent.frame, 1, 1)

  expect_equal(length(mock_load_test_cases), 1)
  expect_args(mock_load_test_cases, 1, test_file_path)

  expect_equal(length(mock_cat), 1)
  expect_args(mock_cat, 1, results$repr())

  # check that it doesn't print if show_results is false
  check(test_file_path, show_results = FALSE)
  expect_equal(length(mock_cat), 1)

  # check that it errors if no test file is provided
  expect_error(check(), regexp = "must have a test file")
})


test_that("correctly includes the test file point value in the TestFileR", {
  test_env <- new.env()
  mock_parent.frame <- mock(test_env, cycle = TRUE)
  stub(check, "parent.frame", mock_parent.frame)

  mock_cat <- mock()
  stub(check, "cat", mock_cat)

  mock_load_test_cases <- mock(list(
    cases = list(ottr::TestCase$new(name = "q1")),
    points = 1
  ), cycle = TRUE)
  stub(check, "load_test_cases", mock_load_test_cases)
  test_file_path <- "tests/q1.r"

  results <- check(test_file_path)

  expect_equal(results$points, 1)
})

#' Run the test cases in a test file
#'
#' @description Execute checks in a test suite and return the [TestFileResult] object from executing
#' the test. Optionally prints results of the test to console.
#'
#' @param test_file Path to a test file
#' @param test_env An environment against which to run tests
#' @param show_results Whether to print the results to stdout
#'
#' @return The parsed test results for the suite
#' @export
#'
#' @examples
#' \dontrun{
#' check("tests/q1.R")
#' }
check <- function(test_file, test_env, show_results) {
  # need to specify a test file
  if (missing(test_file)) {
    stop("must have a test file")
  }

  # if show_results is not passed, default to TRUE
  if (missing(show_results)) {
    show_results <- TRUE
  }

  # grab the calling frame
  if (missing(test_env)) {
    test_env <- parent.frame(1)
  }

  eval("options(testthat.use_colours = FALSE)", test_env)

  test_suite <- list()
  test_case_results <- c()

  # redirect stdout so that testthat doesn't print
  testthat::capture_output({
    # read the test cases from the test file
    test_suite <- load_test_cases(test_file)
    test_cases <- test_suite$cases

    # run the tests
    for (tc in test_cases) {
      err <- tc$run(test_env)
      test_case_results <- c(test_case_results, TestCaseResult$new(is.null(err), err, tc))
    }
  })

  file_result <- TestFileResult$new(test_file, test_case_results, test_suite$points)

  # collect the result if needed
  if (!is.null(get_collector())) {
    get_collector()$add_result(file_result)
  }

  # print out suite_results if show_results is TRUE
  if (show_results) {
    cat(file_result$repr())
  }

  # return the test suite results
  return(file_result)
}

test_that("collects calls to ottr::check in a list", {
  list_name <- parse(text = "my_list_abc123")[[1]]
  tree <- as.list(parse(text = "
    ans.1 = 2
    . = ottr::check('q1')

    foo = function(x) x ^ 2
    ans.2 = foo(4)

    . = ottr::check('q2')

    df = foo %>% sample(10)
    ottr::check('q3')
  "))

  fixed_tree <- update_ast_check_calls(tree, list_name)

  expect_equal(paste(fixed_tree, collapse = "\n"), paste(c(
    "ans.1 = 2",
    "my_list_abc123[[1]] = ottr::check(\"q1\")",
    "foo = function(x) x^2",
    "ans.2 = foo(4)",
    "my_list_abc123[[2]] = ottr::check(\"q2\")",
    "df = foo %>% sample(10)",
    "ottr::check(\"q3\")"
  ), collapse = "\n"))
})

test_that("components integrate correctly", {
  script_path <- test_path("script.R")
  withr::defer(file.remove(script_path))

  check_code <- paste(
    "ottr::check(\"",
    Sys.glob(test_path("files", "integration_test_cases", "*.[Rr]")),
    "\")",
    sep = "",
    collapse = "\n"
  )

  run_test <- function(code, ...) {
    code_with_checks <- paste0(code, "\n", check_code)
    writeLines(code_with_checks, script_path, sep = "\n")
    results_json <- run_autograder(script_path)
    got <- as.character(stringr::str_replace_all(results_json, r"(\\u001b\[\d\dm)", ""))
    want <- NULL
    # go through all valid JSON file paths and check if any matches; if it does, use that one, otherwise
    # use the first one
    for (p in c(...)) {
      pc <- paste(readLines(p, warn = FALSE), collapse = "\n")
      if (is.null(want)) {
        want <- pc
      }
      if (got == pc) {
        want <- pc
        break
      }
    }
    testthat::expect_equal(want, got)
  }

  passes_all <- "
    x <- 2
    square <- function(x) x ^ 2
    y <- paste0(\"hi there, \", c(\"a\", \"b\", \"c\"), \"!\")
  "
  run_test(
    passes_all,
    test_path("files", "integration_expected_results", "passes_all.json"),
    test_path("files", "integration_expected_results_rounding", "passes_all.json"),
    test_path("files", "integration_expected_results_new_testthat", "passes_all.json"))

  fails_2_hidden <- paste0(passes_all, "\nsquare <- function(x) 1")
  run_test(
    fails_2_hidden,
    test_path("files", "integration_expected_results", "fails_2_hidden.json"),
    test_path("files", "integration_expected_results_rounding", "fails_2_hidden.json"),
    test_path("files", "integration_expected_results_new_testthat", "fails_2_hidden.json"))

  fails_3 <- paste0(passes_all, "\ny <- c(1, 2)")
  run_test(
    fails_3,
    test_path("files", "integration_expected_results", "fails_3.json"),
    test_path("files", "integration_expected_results_rounding", "fails_3.json"),
    test_path("files", "integration_expected_results_new_testthat", "fails_3.json"))
})

#' Check whether a string is valid R code
#'
#' @description Determine whether a code snippet has any syntax errors.
#'
#' @param script The code snippet
#'
#' @return Whether the code snippet is valid (can be parsed with `parse`)
#' @export
#'
#' @examples
#' s = "
#' a = TRUE
#' b = c(1, 2, 3)
#' d = function(x) x ^ 2
#' f = d(b)
#' "
#' valid_syntax(s)
#' #> [1] TRUE
#'
#' s = "
#' if (TRUE) {
#'   a = c(1, 2)
#' "
#' valid_syntax(s)
#' #> [1] FALSE
valid_syntax <- function(script) {
  error <- FALSE
  tryCatch(
    parse(text = script),
    error = function(e) error <<- TRUE
  )
  return(!error)
}

#' Determine whether this R session is running on Jupyter.
#'
#' @description Determine whether this R session is running on Jupyter by checking for a CommManager
#' in IRkernel.
#'
#' @return A boolean indicating whether IRkernel is running.
#'
#' @examples
#' \dontrun{
#' running_on_jupyter()
#' }
running_on_jupyter <- function() {
  if (!requireNamespace("IRkernel", quietly = TRUE)) {
    stop("IRkernel is not installed")
  }
  return(!is.null(IRkernel::comm_manager()))
}

library(mockery)

test_that("checks for a CommManager in IRkernel", {
  mock_comm_manager <- mock(TRUE, NULL)
  stub(running_on_jupyter, "IRkernel::comm_manager", mock_comm_manager)

  expect_true(running_on_jupyter())

  expect_false(running_on_jupyter())
})

test_that("recognizes valid syntax", {
  s = "
    a = TRUE
    b = c(1, 2, 3)
    d = function(x) x ^ 2
    f = d(b)
  "
  expect_true(valid_syntax(s))
})

test_that("recognizes invalid syntax", {
  s = "
    if (TRUE) {
      a = c(1, 2)
  "
  expect_false(valid_syntax(s))
})

#' Grade an R script against test files in a directory
#'
#' @description Run autograder in a Gradescope container and return the results as a
#' properly-formatted JSON string.
#'
#' @param script_path The path to the script
#' @param ignore_errors Whether to ignore errors thrown while executing the script
#' @param test_dir A directory of tests to glob from
#'
#' @return The JSON string
#' @export
#'
#' @examples
#' \dontrun{
#' run_autograder("hw01.R", "ABC123", TRUE, "tests")
#' }
run_autograder <- function(script_path, ignore_errors, test_dir) {
  if (missing(ignore_errors)) {
    ignore_errors <- TRUE
  }

  if (missing(test_dir)) {
    test_dir <- "/autograder/source/tests"
  }

  grading_results <- grade_script(script_path, paste0(test_dir, "/*.[Rr]"), ignore_errors)
  return(grading_results$to_json())
}

library(mockery)

test_that("grades an R script and returns a JSON object of results", {
  set.seed(42)
  test_file_results <- make_test_file_results()
  grading_results <- GradingResults$new(test_file_results)

  mock_grade_script <- mock(grading_results)
  stub(run_autograder, "grade_script", mock_grade_script)

  ret <- run_autograder("hw01.R")

  expect_equal(ret, grading_results$to_json())

  expect_equal(length(mock_grade_script), 1)
  expect_args(mock_grade_script, 1, "hw01.R", "/autograder/source/tests/*.[Rr]", TRUE)
})

#' An R6 class representing a collection of test case results
#'
#' @description A collection of test case results that correspond to a single test file.
#'
#' @field test_file_results The [TestFileResult] objects that make up this grading
GradingResults <- R6::R6Class(
  "GradingResults",
  public = list(
    test_file_results = NA,

    #' @description Create a grading result.
    #'
    #' @param test_file_results The [TestFileResult] objects that make up this grading
    #' result
    initialize = function(test_file_results) {
      self$test_file_results <- test_file_results
    },

    #' @description Convert these results to a JSON-like `list` that can be convert to a
    #' `GradingResults` object by Otter's Python library.
    #'
    #' The returned list has the JSON format
    #'
    #' ```
    #' {
    #'   "test_file_results": [
    #'     {
    #'       // output of TestFileResult$to_list
    #'     }
    #'   ]
    #' }
    #' ```
    #'
    #' @return The generated list
    to_list = function() {
      out <- list(
        test_file_results = list()
      )
      for (i in seq_along(self$test_file_results)) {
        out$test_file_results[[i]] <- self$test_file_results[[i]]$to_list()
      }
      return(out)
    },

    #' @description Export these results to a JSON string.
    #'
    #' @importFrom jsonlite toJSON
    #'
    #' @return The JSON string
    to_json = function() {
      return(jsonlite::toJSON(self$to_list(), auto_unbox = TRUE, pretty = TRUE, null = "null"))
    }
  )
)

test_that("$new() initializes fields correctly", {
  tfrs <- make_test_file_results()

  gr <- GradingResults$new(tfrs)

  expect_equal(gr$test_file_results, tfrs)
})

test_that("$to_list() returns the grading results as a list", {
  tfrs <- make_test_file_results()

  gr <- GradingResults$new(tfrs)

  expect_equal(gr$to_list(), make_test_file_results_list())
})

test_that("$to_json() returns the grading results as JSON", {
  tfrs <- make_test_file_results()

  gr <- GradingResults$new(tfrs)

  expect_equal(
    gr$to_json(),
    jsonlite::toJSON(make_test_file_results_list(), auto_unbox = TRUE, pretty = TRUE, null = "null")
  )
})

#' An R6 class for collecting [TestFileResult] objects during grading.
#'
#' @description A collection of test file results created while grading an assignment
#'
#' @field test_file_results The [TestFileResult] objects created during grading
CheckCollector <- R6::R6Class(
  "CheckCollector",
  public = list(
    test_file_results = NA,

    #' @description Create a [CheckCollector].
    initialize = function() {
      self$test_file_results <- list()
    },

    #' Add a [TestFileResult] to this collector.
    #' 
    #' @param test_file_result The [TestFileResult] to add
    add_result = function(test_file_result) {
      self$test_file_results <- append(self$test_file_results, test_file_result)
    },

    #' Retrieve the list [TestFileResult] objects stored in this collector.
    #' 
    #' @return The list of [TestFileResult] objects
    get_results = function() {
      return(self$test_file_results)
    }
  )
)

#' An environment into which a collector will be initialized (so we don't need to update
#' global variables).
collector_env <- new.env()

#' The name of the active collector variable in [collector_env]
collector_varname <- "collector"

#' Create a new global [CheckCollector]
initialize_collector <- function() {
  collector_env[[collector_varname]] <- CheckCollector$new()
}

#' Retrieve the global [CheckCollector]
get_collector <- function() {
  return(collector_env[[collector_varname]])
}

test_that("CheckCollector works", {
  collector <- CheckCollector$new()
  expect_equal(collector$get_results(), list())

  res1 <- TestFileResult$new(list(), "foo.R")
  collector$add_result(res1)
  expect_equal(collector$get_results(), list(res1))

  res2 <- TestFileResult$new(list(), "bar.R")
  collector$add_result(res2)
  expect_equal(collector$get_results(), list(res1, res2))
})

test_that("initialize_collector and get_collector work", {
  expect_true(is.null(get_collector()))

  initialize_collector()
  collector <- get_collector()
  expect_false(is.null(collector))
  expect_true(inherits(collector, "CheckCollector"))

  initialize_collector()
  expect_true(inherits(get_collector(), "CheckCollector"))
  expect_false(identical(collector, get_collector()))
})

#' Attempt to save the current notebook.
#'
#' @description Attempt to save the notebook by displaying Javascript if running on Jupyter. This
#' function waits until the modification time of the file has changed or until the specified timeout
#' expires.
#'
#' @param nb_path The path to the notebook
#' @param timeout Number of seconds to wait for save
#'
#' @return A boolean indicating whether the file was saved successfully. If
#' Jupyter is not running, this function returns TRUE.
#'
#' @examples
#' \dontrun{
#' save_notebook("foo.ipynb")
#' }
save_notebook <- function(nb_path, timeout = 10) {
  if (!running_on_jupyter()) {
    return(TRUE)
  }

  if (!requireNamespace("IRdisplay", quietly = TRUE)) {
    stop("IRdisplay is not installed")
  }

  orig_mod_time = file.mtime(nb_path)
  start = Sys.time()
  IRdisplay::display_javascript("
    if (typeof Jupyter !== 'undefined') {
      Jupyter.notebook.save_checkpoint();
    } else if ('__ottr_force_save_labextension_force_save' in window) {
      window.__ottr_force_save_labextension_force_save();
    }
  ")

  timeout <- as.difftime(timeout, units = "secs")
  while (Sys.time() - start < timeout) {
    curr_mod_time = file.mtime(nb_path)
    if (orig_mod_time < curr_mod_time && file.size(nb_path) > 0) {
      return(TRUE)
    }

    Sys.sleep(0.2)
  }

  return(FALSE)
}

library(mockery)

test_that("saves the notebook by displaying Javascript", {
  stub(save_notebook, "running_on_jupyter", TRUE)
  stub(save_notebook, "file.mtime", mock(Sys.time(), cycle = TRUE))
  stub(save_notebook, "file.size", mock(1, cycle = TRUE))

  mock_display_javascript <- mock()
  stub(save_notebook, "IRdisplay::display_javascript", mock_display_javascript)

  expect_true(save_notebook("foo.ipynb"))

  expect_called(mock_display_javascript, 1)
})

test_that("handles save failure", {
  stub(save_notebook, "running_on_jupyter", TRUE)
  now <- Sys.time()
  stub(save_notebook, "file.mtime", mock(now, cycle = TRUE))
  stub(save_notebook, "file.size", mock(1, cycle = TRUE))

  mock_display_javascript <- mock()
  stub(save_notebook, "IRdisplay::display_javascript", mock_display_javascript)

  timeout <- 2
  start <- Sys.time()
  expect_false(save_notebook("foo.ipynb", timeout = timeout))
  stop <- Sys.time()

  expect_true(stop - start > as.difftime(timeout, units = "secs"))

  expect_called(mock_display_javascript, 1)
})

test_that("does nothing if not running on Jupyter", {
  stub(save_notebook, "running_on_jupyter", FALSE)

  mock_display_javascript <- mock()
  stub(save_notebook, "IRdisplay::display_javascript", mock_display_javascript)

  expect_true(save_notebook("foo.ipynb"))

  expect_called(mock_display_javascript, 0)
})

#' Grade an R script against a series of test files
#'
#' @description Execute a script, parse check outputs, and run additional tests specified by the
#' glob pattern `tests_glob` on the test environment.
#'
#' @param script_path The path to the script
#' @param tests_glob The pattern to search for extra tests
#' @param ignore_errors Whether to ignore errors thrown while executing the script
#'
#' @return The [GradingResults] object after executing tests referenced in the script
#' and those specified by `tests_glob`
grade_script <- function(script_path, tests_glob, ignore_errors) {
  # convert script to a string
  script <- paste(readLines(script_path), collapse = "\n")

  if (missing(ignore_errors)) {
    ignore_errors <- TRUE
  }

  # initialize the collector and store it
  initialize_collector()
  check_collector <- get_collector()

  # run the script and extract results from env, capturing stdout
  testthat::capture_output({
    test_env <- execute_script(script, ignore_errors)
  }, print = TRUE)

  test_file_results <- check_collector$get_results()

  # run the tests in tests_glob on the env, collect in test_file_results
  num_embedded_tests <- length(test_file_results)
  tests_glob <- Sys.glob(tests_glob)
  i <- 1
  for (test_file in tests_glob) {
    already_tested <- sapply(test_file_results, function(tfr) tfr$get_basename())
    if (!(basename(test_file) %in% already_tested)) {
      test_file_results[[i + num_embedded_tests]] <- check(test_file, test_env, FALSE)
      i <- i + 1
    }
  }

  return(GradingResults$new(test_file_results))
}

library(mockery)

test_that("grades a script and returns a list of TestFileResult objects", {
  set.seed(42)

  test_file_result <- make_test_file_results()[[1]]

  mock_check <- mock(test_file_result, cycle = TRUE)
  stub(grade_script, "check", mock_check)

  env <- new.env()
  mock_execute_script <- mock(env, cycle = TRUE)
  stub(grade_script, "execute_script", mock_execute_script)

  tests_dir <- "my_tests"
  dir.create(tests_dir)
  file.create(file.path(tests_dir, "q1.R"))
  file.create(file.path(tests_dir, "q2.R"))
  tests_glob <- file.path(tests_dir, "*.[Rr]")
  withr::defer(unlink(tests_dir, recursive = TRUE))

  script_path <- "my_script.R"
  script_lines <- c("a = 1", "b = 2", "square = function(x) x ^ 2", "c = square(2)")
  script <- paste(script_lines, collapse = "\n")
  writeLines(script_lines, script_path)
  withr::defer(file.remove(script_path))

  results <- grade_script(script_path, tests_glob)

  expect_equal(results, GradingResults$new(c(test_file_result, test_file_result)))

  expect_equal(length(mock_execute_script), 1)
  expect_args(mock_execute_script, 1, script, TRUE)

  expect_equal(length(mock_check), 2)
  expect_args(mock_check, 1, file.path(tests_dir, "q1.R"), env, FALSE)
  expect_args(mock_check, 2, file.path(tests_dir, "q2.R"), env, FALSE)
})

#' Load test cases from a test file
#'
#' @description Load test case data from a test file. Executes the file and grabs the global `test`
#' variable, which should be a `list`.
#'
#' @param test_file The path to the test file
#'
#' @return The test cases
load_test_cases <- function(test_file) {
  env <- new.env()

  exps <- parse(file = test_file)

  for (i in seq_along(exps)) {
    exp <- exps[i]
    eval(exp, envir = env)
  }

  if (!("test" %in% names(env))) {
    stop(paste0("Test file does not declare a global test variable: ", test_file))
  }

  # add names to any test cases missing them
  test_suite <- env$test
  if (is.null(test_suite$name)) {
    test_suite$name <- tools::file_path_sans_ext(basename(test_file))
  }

  for (i in seq_along(test_suite$cases)) {
    tc <- test_suite$cases[[i]]
    if (is.na(tc$name)) {
      tc$name <- paste(test_suite$name, "-", i)
    }
  }

  return(test_suite)
}

test_that("parses a test file into a series of test cases", {
  test_file_path <- test_path("files", "example_test_file.R")

  suite <- load_test_cases(test_file_path)

  expect_equal(length(suite), 2)
  expect_equal(suite$name, "q1")
  expect_equal(suite$cases, make_test_cases())
})

test_that("supplies a name to the suite if none is provided", {
  test_file_path <- test_path("files", "another_test_file.R")
  lines <- readLines(test_path("files", "example_test_file.R"))
  lines <- lines[!stringr::str_detect(lines, "^  name = \"q1\"")]
  writeLines(lines, test_file_path)
  withr::defer(file.remove(test_file_path))

  suite <- load_test_cases(test_file_path)

  expect_equal(suite$cases, make_test_cases("another_test_file"))
})

test_that("fails for a test file with no `test` variable", {
  test_file_path <- test_path("files", "a_bad_test_file.R")
  writeLines(c("s = 1", "foo <- 'bar'"), test_file_path)
  withr::defer(file.remove(test_file_path))

  expect_error(
    load_test_cases(test_file_path),
    regexp = paste0("Test file does not declare a global test variable: ", test_file_path)
  )
})

#' An R6 class representing a test case
#'
#' @description A test case for Ottr. Contains configurations and code to be executed for the test.
#'
#' @field name The name of the test case
#' @field code The code to be executed as part of the test case
#' @field points The point value of the test case
#' @field hidden Whether the test case is hidden
#' @field success_message A message to show to students if the test passes
#' @field failure_message A message to show to students if the test fails
#'
#' @importFrom R6 R6Class
#'
#' @export
#'
#' @examples
#' tc = TestCase$new("q1", {
#'   testthat::assert_true(q1.ans)
#' })
#' env = new.env()
#' env$q1.ans = TRUE
#' tc$run(env)
TestCase <- R6::R6Class(
  "TestCase",
  public = list(
    name = NA,
    code = NA,
    points = NA,
    hidden = NA,
    success_message = NA,
    failure_message = NA,

    #' @description Create a test case.
    #'
    #' @param name The name of the test case
    #' @param code The code to be executed as part of the test case
    #' @param points The point value of the test case
    #' @param hidden Whether the test case is hidden
    #' @param success_message A message to show to students if the test passes
    #' @param failure_message A message to show to students if the test fails
    initialize = function(
      name,
      code,
      points = 1,
      hidden = FALSE,
      success_message = NA,
      failure_message = NA
    ) {
      self$name <- name
      self$code <- substitute(code)
      self$points <- points
      self$hidden <- hidden
      self$success_message <- success_message
      self$failure_message <- failure_message
    },

    #' @description Run the test case against the provided environment.
    #'
    #' @param env The environment to run the test case in
    run = function(env) {
      error <- NULL
      tryCatch(
        eval(self$code, envir = env, enclos = baseenv()),
        error = function(e) error <<- e
      )
      return(error)
    },

    #' @description Convert this test case to a JSON-compatible list with all of its fields.
    #'
    #' @return The list representation of this test case
    to_list = function() {
      return(list(
        name = self$name,
        code = paste(deparse(self$code), collapse = "\n"),
        points = self$points,
        hidden = self$hidden,
        success_message = self$success_message,
        failure_message = self$failure_message
      ))
    }
  )
)

get_expected_fields <- function() {
  return(list(
    name = "q1-1",
    code = substitute({
      x <- 1
      testthat::expect_equal(x, 1)
    }),
    points = 2,
    hidden = TRUE,
    success_message = "hi there",
    failure_message = "bye there"
  ))
}

test_that("$new() initializes fields correctly", {
  expected_fields <- get_expected_fields()

  check_fields <- function(field) {
    expect_equal(tc[[field]], expected_fields[[field]])
  }

  tc <- do.call(TestCase$new, expected_fields)
  lapply(names(expected_fields), check_fields)

  # check default value of points
  expected_fields$points <- 1
  tc <- do.call(TestCase$new, expected_fields[names(expected_fields) != "points"])
  lapply(names(expected_fields), check_fields)

  # check default value of hidden
  expected_fields$hidden <- FALSE
  tc <- do.call(TestCase$new, expected_fields[names(expected_fields) != "hidden"])
  lapply(names(expected_fields), check_fields)
})

test_that("$run() runs its code in the provided environment and returns any errors thrown", {
  tc <- TestCase$new("q1-1", {
    x <- 1
    y <- 2 * x
    stop("done")
    z <- y * 3
  })

  env <- new.env()

  err <- tc$run(env)

  expect_equal(env$x, 1)
  expect_equal(env$y, 2)
  expect_false("z" %in% names(env))

  expect_true(inherits(err, "error"))
  expect_equal(err$message, "done")

  # check case when no error is thrown
  tc$code <- substitute({
    a <- 1
    b <- 2 * a
  })

  err <- tc$run(env)

  expect_equal(env$a, 1)
  expect_equal(env$b, 2)

  expect_true(is.null(err))
})

test_that("$to_list() converts itself to a list correctly", {
  expected_fields <- get_expected_fields()

  check_fields <- function(field) {
    expect_equal(tc$to_list()[[field]], expected_fields[[field]])
  }

  tc <- do.call(TestCase$new, expected_fields)

  expect_true(is.list(tc$to_list()))
  expected_fields$code <- "{\n    x <- 1\n    testthat::expect_equal(x, 1)\n}"
  lapply(names(expected_fields), check_fields)
})

#' An R6 class representing a collection of test case results
#'
#' @description A collection of test case results that correspond to a single test file.
#'
#' @field test_case_results The [TestCaseResult] objects that make up this test file
#' @field filename The name of the test file
#' @field points The point value of the test file or a list of test case point values
TestFileResult <- R6::R6Class(
  "TestFileResult",
  public = list(
    test_case_results = NA,
    filename = NA,
    points = NA,

    #' @description Create a test file result.
    #'
    #' @param filename The name of the test file
    #' @param test_case_results The [TestCaseResult] objects that make up this test file
    #' @param points The point value of the test file or a list of test case point values
    initialize = function(filename, test_case_results, points = NULL) {
      self$filename <- filename
      self$test_case_results <- test_case_results
      self$points <- points
    },

    #' @description Get the basename of the file this result corresponds to.
    #'
    #' @return The basename of the test file
    get_basename = function() basename(self$filename),

    #' @description Get the total score earned for this test file as a percentage. Uses
    #' [`TestCaseResult$get_score()`][TestCaseResult] to determine the points earned for each test
    #' case.
    #'
    #' @return The score as a percentage.
    get_score = function() {
      earned <- 0
      possible <- 0
      for (tcr in self$test_case_results) {
        earned <- earned + tcr$get_score()
        possible <- possible + tcr$test_case$points
      }
      return(ifelse(possible == 0, 0, earned / possible))
    },

    #' @description Convert this result into a human-readable string for display.
    #'
    #' @return The string representation of this result
    repr = function() {
      # if all tests passed, just return that
      messages <- c()
      for (tcr in self$test_case_results) {
        if (!is.na(tcr$get_message())) {
          messages <- c(messages, tcr$get_message())
        }
      }

      messages <- paste(messages, collapse = "\n")
      if (messages != "") {
        messages <- paste0(messages, "\n")
      }

      if (self$get_score() == 1) {
        return(paste0(messages, "All tests passed!"))
      }

      # otherwise, iterate through results and put hints together
      output <- c()
      for (tcr in self$test_case_results) {
        output <- c(output, tcr$repr())
      }

      return(paste0(output, collapse = "\n\n"))
    },

    #' @description Convert this result to a JSON-compatible list with all of its fields.
    #'
    #' @return The list representation of this result
    to_list = function() {
      tcr_lists <- list()
      for (i in seq_along(self$test_case_results)) {
        tcr_lists[[i]] = self$test_case_results[[i]]$to_list()
      }

      ret <- list(
        filename = self$filename,
        points = self$points,
        test_case_results = tcr_lists
      )

      return(ret)
    }
  )
)

make_test_case_results <- function() {
  test_cases <- make_test_cases()
  return(lapply(test_cases, function(tc) {
    return(TestCaseResult$new(
      !tc$hidden,
      if (tc$hidden) simpleError("failed") else NULL,
      tc
    ))
  }))
}

test_that("$new() initializes fields correctly", {
  filename <- "tests/q1.R"
  tcrs <- make_test_case_results()

  tfr <- TestFileResult$new(filename, tcrs)

  expect_equal(tfr$filename, filename)
  expect_equal(tfr$test_case_results, tcrs)

  tfr <- TestFileResult$new(filename, tcrs, 2)

  expect_equal(tfr$filename, filename)
  expect_equal(tfr$test_case_results, tcrs)
  expect_equal(tfr$points, 2)
})

test_that("$get_basename() returns the basename of the test file", {
  filename <- "tests/q1.R"
  tcrs <- make_test_case_results()

  tfr <- TestFileResult$new(filename, tcrs)

  expect_equal(tfr$get_basename(), basename(filename))
})

test_that("$get_score() returns the correct score", {
  filename <- "tests/q1.R"
  tcrs <- make_test_case_results()

  tfr <- TestFileResult$new(filename, tcrs)

  expect_equal(tfr$get_score(), 0.4)
})

test_that("$repr() returns the string representation of the test file results", {
  filename <- "tests/q1.R"
  tcrs <- make_test_case_results()
  tcrs[[1]]$test_case$success_message <- "good"
  tcrs[[3]]$test_case$failure_message <- "bad"

  tfr <- TestFileResult$new(filename, tcrs)

  expect_equal(tfr$repr(), paste(
    "Test q1 - 1 passed",
    "good",
    "",
    "Test q1 - 2 passed",
    "",
    "",
    "Test q1 - 3 failed:",
    "bad",
    "failed",
    "",
    "Test q1d failed:",
    "",
    "failed",
    sep = "\n"
  ))

  # check case when all tests pass
  tfr <- TestFileResult$new(
    "", list(TestCaseResult$new(TRUE, NULL, TestCase$new("", {}, points = 1))))
  expect_equal(tfr$repr(), "All tests passed!")
})

test_that("$to_list() returns the test file results as a list", {
  filename <- "tests/q1.R"
  tcrs <- make_test_case_results()

  tfr <- TestFileResult$new(filename, tcrs)
  tfr_list <- tfr$to_list()

  expect_true(is.list(tfr_list))
  expect_equal(length(tfr_list), 3)
  expect_equal(tfr_list$filename, filename)
  expect_equal(tfr_list$points, NULL)
  expect_equal(tfr_list$test_case_results, lapply(tcrs, function(tcr) tcr$to_list()))

  tfr <- TestFileResult$new(filename, tcrs, 2)
  tfr_list <- tfr$to_list()

  expect_true(is.list(tfr_list))
  expect_equal(length(tfr_list), 3)
  expect_equal(tfr_list$filename, filename)
  expect_equal(tfr_list$test_case_results, lapply(tcrs, function(tcr) tcr$to_list()))
  expect_equal(tfr_list$points, 2)

  tfr <- TestFileResult$new(filename, tcrs, c(1, 1, 1))
  tfr_list <- tfr$to_list()

  expect_true(is.list(tfr_list))
  expect_equal(length(tfr_list), 3)
  expect_equal(tfr_list$filename, filename)
  expect_equal(tfr_list$test_case_results, lapply(tcrs, function(tcr) tcr$to_list()))
  expect_equal(tfr_list$points, c(1, 1, 1))
})

# TODO: convert update_ast_check_calls to also work for calls that aren't in assignment statements
# (i.e.. `ottr::check(...)`, not `. = ottr::check(...)`)

#' Collect results of calls to `ottr::check` in an AST
#'
#' @description Traverse an AST (a list of expressions) and change calls of the form
#' `. = ottr::check(...)` so that they are appended to a list with name `list_name`.
#'
#' If `list_name` is `check_results_XX`, then `. = ottr::check(...)` becomes
#' `check_results_XX[[<int>]] = ottr::check(...)`, where `<int>` is an integer
#'
#' @param tree The tree to traverse
#' @param list_name The quoted name of the list
#'
#' @return The tree with substitutions made
update_ast_check_calls <- function(tree, list_name) {
  list_idx <- 1
  for (i in seq_along(tree)) {
    expr <- tree[[i]]
    if (methods::is(expr, "=")) {
      right_expr <- expr[[3]]
      call <- right_expr[[1]]
      if (length(call) >= 3) {
        pkg <- call[[2]]
        fn <- call[[3]]
        if (pkg == "ottr" && fn == "check") {
          env <- new.env()
          env$list_name <- list_name
          env$list_idx <- list_idx
          new_left_expr <- substitute(list_name[[list_idx]], env)
          expr[[2]] <- new_left_expr
          list_idx <- list_idx + 1
        }
      }
    }
    tree[[i]] <- expr
  }
  return(tree)
}

test <- list(
  name = "q1",
  cases = list(
    ottr::TestCase$new(
      hidden = FALSE,
      name = NA,
      points = 1,
      code = {
        testthat::expect_true(is.numeric(x))
      }
    ),
    ottr::TestCase$new(
      hidden = FALSE,
      name = NA,
      points = 1,
      code = {
        testthat::expect_true(0 < x)
        testthat::expect_true(x < 100)
      }
    ),
    ottr::TestCase$new(
      hidden = TRUE,
      name = NA,
      points = 1,
      code = {
        testthat::expect_equal(x, 2)
      }
    ),
    ottr::TestCase$new(
      hidden = TRUE,
      name = "q1d",
      points = 2,
      success_message = "congrats",
      code = {
        testthat::expect_equal(as.character(x), "2")
      }
    )
  )
)

test <- list(
  name = "q1",
  cases = list(
    ottr::TestCase$new(
      name = "q1-1",
      code = {
        testthat::expect_true(x >= 1)
        testthat::expect_true(x <= 3)
      }
    ),
    ottr::TestCase$new(
      name = "q1-2",
      hidden = TRUE,
      code = {
        testthat::expect_equal(x, 2)
      }
    )
  )
)

test <- list(
  name = "q3",
  cases = list(
    ottr::TestCase$new(
      name = "q3-1",
      code = {
        testthat::expect_equal(length(y), 3)
      }
    ),
    ottr::TestCase$new(
      name = "q3-2",
      hidden = TRUE,
      points = 2,
      code = {
        testthat::expect_equal(y, c("hi there, a!", "hi there, b!", "hi there, c!"))
      },
      success_message = "y is correct",
      failure_message = "y is incorrect"
    )
  )
)

test <- list(
  name = "q2",
  cases = list(
    ottr::TestCase$new(
      name = "q2-1",
      code = {
        testthat::expect_equal(square(1), 1)
        testthat::expect_equal(square(-1), 1)
      },
      success_message = "square works for 1 and -1",
      failure_message = "square doesn't work for 1 and/or -1"
    ),
    ottr::TestCase$new(
      name = "q2-2",
      hidden = TRUE,
      points = 2,
      code = {
        testthat::expect_equal(square(2.5), 6.25)
      }
    )
  )
)

make_test_file_results <- function() {
  return(list(
    TestFileResult$new("tests/q1.R", list(
      TestCaseResult$new(
        TRUE,
        NULL,
        TestCase$new("q1-1", {
          testthat::expect_true(TRUE)
        })
      ),
      TestCaseResult$new(
        TRUE,
        NULL,
        TestCase$new("q1-2", {
          expect_false(FALSE)
        })
      )
    )),
    TestFileResult$new("tests/q2.R", list(
      TestCaseResult$new(
        TRUE,
        NULL,
        TestCase$new("q2-1", {
          testthat::expect_true(TRUE)
        })
      ),
      TestCaseResult$new(
        FALSE,
        NULL,
        TestCase$new("q2-2", {
          expect_false(TRUE)
        }, hidden = TRUE)
      )
    ))
  ))
}

#' Generate a list of sample [TestCase] objects. The list returned should match
#' `test$cases` in `files/example_test_file.R` when `name_override` is not provided.
#'
#' @param name_override The name of the question; defaults to `"q1"`
make_test_cases <- function(name_override) {
  if (missing(name_override)) {
    name_override <- "q1"
  }

  return(list(
    ottr::TestCase$new(
      hidden = FALSE,
      name = paste0(name_override, " - 1"),
      points = 1,
      code = {
        testthat::expect_true(is.numeric(x))
      }
    ),
    ottr::TestCase$new(
      hidden = FALSE,
      name = paste0(name_override, " - 2"),
      points = 1,
      code = {
        testthat::expect_true(0 < x)
        testthat::expect_true(x < 100)
      }
    ),
    ottr::TestCase$new(
      hidden = TRUE,
      name = paste0(name_override, " - 3"),
      points = 1,
      code = {
        testthat::expect_equal(x, 2)
      }
    ),
    ottr::TestCase$new(
      hidden = TRUE,
      name = "q1d",
      points = 2,
      success_message = "congrats",
      code = {
        testthat::expect_equal(as.character(x), "2")
      }
    )
  ))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TestCaseResult.R
\name{TestCaseResult}
\alias{TestCaseResult}
\title{An R6 representing the results of running a test case}
\description{
Represents the results of running a test case against a global environment. Contains
metadata about the passing/failing of the test case as well as a reference to the test case
itself.
}
\section{Public fields}{
  \if{html}{\out{<div class="r6-fields">}}
  \describe{
    \item{\code{passed}}{Whether the test passed}

    \item{\code{error}}{An error raised by executing the test, if any}

    \item{\code{test_case}}{The \link{TestCase} that this result tracks}
  }
  \if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-TestCaseResult-initialize}{\code{TestCaseResult$new()}}
    \item \href{#method-TestCaseResult-get_score}{\code{TestCaseResult$get_score()}}
    \item \href{#method-TestCaseResult-repr}{\code{TestCaseResult$repr()}}
    \item \href{#method-TestCaseResult-to_list}{\code{TestCaseResult$to_list()}}
    \item \href{#method-TestCaseResult-get_message}{\code{TestCaseResult$get_message()}}
    \item \href{#method-TestCaseResult-clone}{\code{TestCaseResult$clone()}}
  }
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCaseResult-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-TestCaseResult-initialize}{}}}
\subsection{\code{TestCaseResult$new()}}{
  Create a test case result.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCaseResult$new(passed, error, test_case)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{passed}}{Whether the test passed}
      \item{\code{error}}{An error raised by executing the test, if any}
      \item{\code{test_case}}{The \code{TestCase} that this result tracks}
    }
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCaseResult-get_score"></a>}}
\if{latex}{\out{\hypertarget{method-TestCaseResult-get_score}{}}}
\subsection{\code{TestCaseResult$get_score()}}{
  Get the score earned for this test case, accounting for whether the test passed
or failed.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCaseResult$get_score()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The score
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCaseResult-repr"></a>}}
\if{latex}{\out{\hypertarget{method-TestCaseResult-repr}{}}}
\subsection{\code{TestCaseResult$repr()}}{
  Convert this result into a human-readable string for display.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCaseResult$repr()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The string representation of this result
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCaseResult-to_list"></a>}}
\if{latex}{\out{\hypertarget{method-TestCaseResult-to_list}{}}}
\subsection{\code{TestCaseResult$to_list()}}{
  Convert this result to a JSON-compatible list with all of its fields.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCaseResult$to_list()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The list representation of this result
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCaseResult-get_message"></a>}}
\if{latex}{\out{\hypertarget{method-TestCaseResult-get_message}{}}}
\subsection{\code{TestCaseResult$get_message()}}{
  Get the message to be displayed to the student based on whether the test case
passed or failed, if any.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCaseResult$get_message()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The message or \code{NA}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCaseResult-clone"></a>}}
\if{latex}{\out{\hypertarget{method-TestCaseResult-clone}{}}}
\subsection{\code{TestCaseResult$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCaseResult$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check.R
\name{check}
\alias{check}
\title{Run the test cases in a test file}
\usage{
check(test_file, test_env, show_results)
}
\arguments{
\item{test_file}{Path to a test file}

\item{test_env}{An environment against which to run tests}

\item{show_results}{Whether to print the results to stdout}
}
\value{
The parsed test results for the suite
}
\description{
Execute checks in a test suite and return the \link{TestFileResult} object from executing
the test. Optionally prints results of the test to console.
}
\examples{
\dontrun{
check("tests/q1.R")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_collector.R
\name{collector_env}
\alias{collector_env}
\title{An environment into which a collector will be initialized (so we don't need to update
global variables).}
\usage{
collector_env
}
\description{
An environment into which a collector will be initialized (so we don't need to update
global variables).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/export.R
\name{export}
\alias{export}
\title{Export a submission to a zip file}
\usage{
export(
  submission_path,
  export_path = NULL,
  display_link = TRUE,
  pdf = FALSE,
  force_save = FALSE,
  debug = FALSE
)
}
\arguments{
\item{submission_path}{The path to the submission}

\item{export_path}{The path at which to write the zip file (optional)}

\item{display_link}{Whether to display a download link with \code{IRdisplay}}

\item{pdf}{Whether to include a PDF of the submission (only works for Rmd, Quarto, and ipynb files)}

\item{force_save}{Whether to attempt to force-save the notebook if running on Jupyter}

\item{debug}{Whether to stop on PDF generation errors}
}
\description{
Export a submission to a zip file for submitting. If indicated, a PDF of the
submission is generated and included in the zip file. (PDF generation is only supported for Rmd,
Quarto, and ipynb files.)
}
\examples{
\dontrun{
export("hw01.ipynb")

# with pdf
export("hw01.ipynb", pdf = TRUE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GradingResults.R
\name{GradingResults}
\alias{GradingResults}
\title{An R6 class representing a collection of test case results}
\description{
A collection of test case results that correspond to a single test file.
}
\section{Public fields}{
  \if{html}{\out{<div class="r6-fields">}}
  \describe{
    \item{\code{test_file_results}}{The \link{TestFileResult} objects that make up this grading}
  }
  \if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-GradingResults-initialize}{\code{GradingResults$new()}}
    \item \href{#method-GradingResults-to_list}{\code{GradingResults$to_list()}}
    \item \href{#method-GradingResults-to_json}{\code{GradingResults$to_json()}}
    \item \href{#method-GradingResults-clone}{\code{GradingResults$clone()}}
  }
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-GradingResults-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-GradingResults-initialize}{}}}
\subsection{\code{GradingResults$new()}}{
  Create a grading result.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{GradingResults$new(test_file_results)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{test_file_results}}{The \link{TestFileResult} objects that make up this grading
result}
    }
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-GradingResults-to_list"></a>}}
\if{latex}{\out{\hypertarget{method-GradingResults-to_list}{}}}
\subsection{\code{GradingResults$to_list()}}{
  Convert these results to a JSON-like \code{list} that can be convert to a
\code{GradingResults} object by Otter's Python library.

The returned list has the JSON format

\if{html}{\out{<div class="sourceCode">}}\preformatted{\{
  "test_file_results": [
    \{
      // output of TestFileResult$to_list
    \}
  ]
\}
}\if{html}{\out{</div>}}
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{GradingResults$to_list()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The generated list
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-GradingResults-to_json"></a>}}
\if{latex}{\out{\hypertarget{method-GradingResults-to_json}{}}}
\subsection{\code{GradingResults$to_json()}}{
  Export these results to a JSON string.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{GradingResults$to_json()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The JSON string
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-GradingResults-clone"></a>}}
\if{latex}{\out{\hypertarget{method-GradingResults-clone}{}}}
\subsection{\code{GradingResults$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{GradingResults$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TestFileResult.R
\name{TestFileResult}
\alias{TestFileResult}
\title{An R6 class representing a collection of test case results}
\description{
A collection of test case results that correspond to a single test file.
}
\section{Public fields}{
  \if{html}{\out{<div class="r6-fields">}}
  \describe{
    \item{\code{test_case_results}}{The \link{TestCaseResult} objects that make up this test file}

    \item{\code{filename}}{The name of the test file}

    \item{\code{points}}{The point value of the test file or a list of test case point values}
  }
  \if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-TestFileResult-initialize}{\code{TestFileResult$new()}}
    \item \href{#method-TestFileResult-get_basename}{\code{TestFileResult$get_basename()}}
    \item \href{#method-TestFileResult-get_score}{\code{TestFileResult$get_score()}}
    \item \href{#method-TestFileResult-repr}{\code{TestFileResult$repr()}}
    \item \href{#method-TestFileResult-to_list}{\code{TestFileResult$to_list()}}
    \item \href{#method-TestFileResult-clone}{\code{TestFileResult$clone()}}
  }
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestFileResult-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-TestFileResult-initialize}{}}}
\subsection{\code{TestFileResult$new()}}{
  Create a test file result.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestFileResult$new(filename, test_case_results, points = NULL)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{filename}}{The name of the test file}
      \item{\code{test_case_results}}{The \link{TestCaseResult} objects that make up this test file}
      \item{\code{points}}{The point value of the test file or a list of test case point values}
    }
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestFileResult-get_basename"></a>}}
\if{latex}{\out{\hypertarget{method-TestFileResult-get_basename}{}}}
\subsection{\code{TestFileResult$get_basename()}}{
  Get the basename of the file this result corresponds to.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestFileResult$get_basename()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The basename of the test file
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestFileResult-get_score"></a>}}
\if{latex}{\out{\hypertarget{method-TestFileResult-get_score}{}}}
\subsection{\code{TestFileResult$get_score()}}{
  Get the total score earned for this test file as a percentage. Uses
\code{\link[=TestCaseResult]{TestCaseResult$get_score()}} to determine the points earned for each test
case.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestFileResult$get_score()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The score as a percentage.
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestFileResult-repr"></a>}}
\if{latex}{\out{\hypertarget{method-TestFileResult-repr}{}}}
\subsection{\code{TestFileResult$repr()}}{
  Convert this result into a human-readable string for display.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestFileResult$repr()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The string representation of this result
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestFileResult-to_list"></a>}}
\if{latex}{\out{\hypertarget{method-TestFileResult-to_list}{}}}
\subsection{\code{TestFileResult$to_list()}}{
  Convert this result to a JSON-compatible list with all of its fields.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestFileResult$to_list()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The list representation of this result
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestFileResult-clone"></a>}}
\if{latex}{\out{\hypertarget{method-TestFileResult-clone}{}}}
\subsection{\code{TestFileResult$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestFileResult$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_collector.R
\name{initialize_collector}
\alias{initialize_collector}
\title{Create a new global \link{CheckCollector}}
\usage{
initialize_collector()
}
\description{
Create a new global \link{CheckCollector}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_collector.R
\name{get_collector}
\alias{get_collector}
\title{Retrieve the global \link{CheckCollector}}
\usage{
get_collector()
}
\description{
Retrieve the global \link{CheckCollector}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/grade_script.R
\name{grade_script}
\alias{grade_script}
\title{Grade an R script against a series of test files}
\usage{
grade_script(script_path, tests_glob, ignore_errors)
}
\arguments{
\item{script_path}{The path to the script}

\item{tests_glob}{The pattern to search for extra tests}

\item{ignore_errors}{Whether to ignore errors thrown while executing the script}
}
\value{
The \link{GradingResults} object after executing tests referenced in the script
and those specified by \code{tests_glob}
}
\description{
Execute a script, parse check outputs, and run additional tests specified by the
glob pattern \code{tests_glob} on the test environment.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/load_test_cases.R
\name{load_test_cases}
\alias{load_test_cases}
\title{Load test cases from a test file}
\usage{
load_test_cases(test_file)
}
\arguments{
\item{test_file}{The path to the test file}
}
\value{
The test cases
}
\description{
Load test case data from a test file. Executes the file and grabs the global \code{test}
variable, which should be a \code{list}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/update_ast_check_calls.R
\name{update_ast_check_calls}
\alias{update_ast_check_calls}
\title{Collect results of calls to \code{ottr::check} in an AST}
\usage{
update_ast_check_calls(tree, list_name)
}
\arguments{
\item{tree}{The tree to traverse}

\item{list_name}{The quoted name of the list}
}
\value{
The tree with substitutions made
}
\description{
Traverse an AST (a list of expressions) and change calls of the form
\code{. = ottr::check(...)} so that they are appended to a list with name \code{list_name}.

If \code{list_name} is \code{check_results_XX}, then \code{. = ottr::check(...)} becomes
\verb{check_results_XX[[<int>]] = ottr::check(...)}, where \verb{<int>} is an integer
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_collector.R
\name{CheckCollector}
\alias{CheckCollector}
\title{An R6 class for collecting \link{TestFileResult} objects during grading.}
\description{
A collection of test file results created while grading an assignment
}
\section{Public fields}{
  \if{html}{\out{<div class="r6-fields">}}
  \describe{
    \item{\code{test_file_results}}{The \link{TestFileResult} objects created during grading}
  }
  \if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-CheckCollector-initialize}{\code{CheckCollector$new()}}
    \item \href{#method-CheckCollector-add_result}{\code{CheckCollector$add_result()}}
    \item \href{#method-CheckCollector-get_results}{\code{CheckCollector$get_results()}}
    \item \href{#method-CheckCollector-clone}{\code{CheckCollector$clone()}}
  }
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-CheckCollector-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-CheckCollector-initialize}{}}}
\subsection{\code{CheckCollector$new()}}{
  Create a \link{CheckCollector}.
Add a \link{TestFileResult} to this collector.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{CheckCollector$new()}
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-CheckCollector-add_result"></a>}}
\if{latex}{\out{\hypertarget{method-CheckCollector-add_result}{}}}
\subsection{\code{CheckCollector$add_result()}}{
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{CheckCollector$add_result(test_file_result)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{test_file_result}}{The \link{TestFileResult} to add
Retrieve the list \link{TestFileResult} objects stored in this collector.}
    }
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-CheckCollector-get_results"></a>}}
\if{latex}{\out{\hypertarget{method-CheckCollector-get_results}{}}}
\subsection{\code{CheckCollector$get_results()}}{
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{CheckCollector$get_results()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The list of \link{TestFileResult} objects
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-CheckCollector-clone"></a>}}
\if{latex}{\out{\hypertarget{method-CheckCollector-clone}{}}}
\subsection{\code{CheckCollector$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{CheckCollector$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R, R/valid_syntax.R
\name{valid_syntax}
\alias{valid_syntax}
\title{Check whether a string is valid R code}
\usage{
valid_syntax(script)

valid_syntax(script)
}
\arguments{
\item{script}{The code snippet}
}
\value{
Whether the code snippet is valid (can be parsed with \code{parse})

Whether the code snippet is valid (can be parsed with \code{parse})
}
\description{
Determine whether a code snippet has any syntax errors.

Determine whether a code snippet has any syntax errors.
}
\examples{
s = "
a = TRUE
b = c(1, 2, 3)
d = function(x) x ^ 2
f = d(b)
"
valid_syntax(s)
#> [1] TRUE

s = "
if (TRUE) {
  a = c(1, 2)
"
valid_syntax(s)
#> [1] FALSE
s = "
a = TRUE
b = c(1, 2, 3)
d = function(x) x ^ 2
f = d(b)
"
valid_syntax(s)
#> [1] TRUE

s = "
if (TRUE) {
  a = c(1, 2)
"
valid_syntax(s)
#> [1] FALSE
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_autograder.R
\name{run_autograder}
\alias{run_autograder}
\title{Grade an R script against test files in a directory}
\usage{
run_autograder(script_path, ignore_errors, test_dir)
}
\arguments{
\item{script_path}{The path to the script}

\item{ignore_errors}{Whether to ignore errors thrown while executing the script}

\item{test_dir}{A directory of tests to glob from}
}
\value{
The JSON string
}
\description{
Run autograder in a Gradescope container and return the results as a
properly-formatted JSON string.
}
\examples{
\dontrun{
run_autograder("hw01.R", "ABC123", TRUE, "tests")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_collector.R
\name{collector_varname}
\alias{collector_varname}
\title{The name of the active collector variable in \link{collector_env}}
\usage{
collector_varname
}
\description{
The name of the active collector variable in \link{collector_env}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/save_notebook.R
\name{save_notebook}
\alias{save_notebook}
\title{Attempt to save the current notebook.}
\usage{
save_notebook(nb_path, timeout = 10)
}
\arguments{
\item{nb_path}{The path to the notebook}

\item{timeout}{Number of seconds to wait for save}
}
\value{
A boolean indicating whether the file was saved successfully. If
Jupyter is not running, this function returns TRUE.
}
\description{
Attempt to save the notebook by displaying Javascript if running on Jupyter. This
function waits until the modification time of the file has changed or until the specified timeout
expires.
}
\examples{
\dontrun{
save_notebook("foo.ipynb")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TestCase.R
\name{TestCase}
\alias{TestCase}
\title{An R6 class representing a test case}
\description{
A test case for Ottr. Contains configurations and code to be executed for the test.
}
\examples{
tc = TestCase$new("q1", {
  testthat::assert_true(q1.ans)
})
env = new.env()
env$q1.ans = TRUE
tc$run(env)
}
\section{Public fields}{
  \if{html}{\out{<div class="r6-fields">}}
  \describe{
    \item{\code{name}}{The name of the test case}

    \item{\code{code}}{The code to be executed as part of the test case}

    \item{\code{points}}{The point value of the test case}

    \item{\code{hidden}}{Whether the test case is hidden}

    \item{\code{success_message}}{A message to show to students if the test passes}

    \item{\code{failure_message}}{A message to show to students if the test fails}
  }
  \if{html}{\out{</div>}}
}
\section{Methods}{
\subsection{Public methods}{
  \itemize{
    \item \href{#method-TestCase-initialize}{\code{TestCase$new()}}
    \item \href{#method-TestCase-run}{\code{TestCase$run()}}
    \item \href{#method-TestCase-to_list}{\code{TestCase$to_list()}}
    \item \href{#method-TestCase-clone}{\code{TestCase$clone()}}
  }
}
\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCase-initialize"></a>}}
\if{latex}{\out{\hypertarget{method-TestCase-initialize}{}}}
\subsection{\code{TestCase$new()}}{
  Create a test case.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCase$new(
  name,
  code,
  points = 1,
  hidden = FALSE,
  success_message = NA,
  failure_message = NA
)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{name}}{The name of the test case}
      \item{\code{code}}{The code to be executed as part of the test case}
      \item{\code{points}}{The point value of the test case}
      \item{\code{hidden}}{Whether the test case is hidden}
      \item{\code{success_message}}{A message to show to students if the test passes}
      \item{\code{failure_message}}{A message to show to students if the test fails}
    }
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCase-run"></a>}}
\if{latex}{\out{\hypertarget{method-TestCase-run}{}}}
\subsection{\code{TestCase$run()}}{
  Run the test case against the provided environment.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCase$run(env)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{env}}{The environment to run the test case in}
    }
    \if{html}{\out{</div>}}
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCase-to_list"></a>}}
\if{latex}{\out{\hypertarget{method-TestCase-to_list}{}}}
\subsection{\code{TestCase$to_list()}}{
  Convert this test case to a JSON-compatible list with all of its fields.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCase$to_list()}
    \if{html}{\out{</div>}}
  }
  \subsection{Returns}{
    The list representation of this test case
  }
}

\if{html}{\out{<hr>}}
\if{html}{\out{<a id="method-TestCase-clone"></a>}}
\if{latex}{\out{\hypertarget{method-TestCase-clone}{}}}
\subsection{\code{TestCase$clone()}}{
  The objects of this class are cloneable with this method.
  \subsection{Usage}{
    \if{html}{\out{<div class="r">}}
    \preformatted{TestCase$clone(deep = FALSE)}
    \if{html}{\out{</div>}}
  }
  \subsection{Arguments}{
    \if{html}{\out{<div class="arguments">}}
    \describe{
      \item{\code{deep}}{Whether to make a deep clone.}
    }
    \if{html}{\out{</div>}}
  }
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{running_on_jupyter}
\alias{running_on_jupyter}
\title{Determine whether this R session is running on Jupyter.}
\usage{
running_on_jupyter()
}
\value{
A boolean indicating whether IRkernel is running.
}
\description{
Determine whether this R session is running on Jupyter by checking for a CommManager
in IRkernel.
}
\examples{
\dontrun{
running_on_jupyter()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/execute_script.R
\name{execute_script}
\alias{execute_script}
\title{Generate an environment from an R script}
\usage{
execute_script(script, ignore_errors)
}
\arguments{
\item{script}{The string to be executed}

\item{ignore_errors}{Whether to ignore errors thrown while executing the script}
}
\value{
The global environment after executing the script
}
\description{
Execute a string as an R script and return the environment from that execution.

Converts a string to an AST and executes that script in a dummy environment for running test
cases against. Transforms all expressions of the form \code{. = ottr::check(...)} by replacing the \code{.}
with an index into a list in the environment with name \verb{check_results_\{SECRET\}} to collect the
\link{TestFileResult} objects generated from those checks. (This helps to handle variable
name collisions in tests when grading a script.)
}
